#coding:utf-8

'''
from JiuJiang
树莓酱的操作实例
https:://www.shumeijiang.com
'''
import sys
import RPi.GPIO as GPIO ##引入GPIO模块
import time    ##引入time库
from classes.motorAct import motorAct  #引入动作类
GPIO.setwarnings(False) 

#u型光电传感器
uPin = 17
GPIO.setmode(GPIO.BCM)
GPIO.setup(uPin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN) #初始化u型光电低电压

#动作实例化
motor = motorAct()

#定义多步操作
def walk(step, direction):
    if not step:
        return ;
    if not direction:
        direction = 'forward'

    run = 0
    roundStep = 600 #圈长 大于一圈的长度
    for i in range(0, roundStep):
        tect = GPIO.event_detected(uPin)
        status = GPIO.input(uPin)

        #发现事件且处于高电平
        if tect == 1 and status == GPIO.HIGH:
            run += 1

        if direction == 'backward':
            motor.oneStepBack(0.003)
        elif direction == 'forward':
            motor.oneStep(0.003)

        #检测停止条件
        if run >= step:
            motor.stopMoving()
            break

        time.sleep(0.005)  ##每步间的间隔
        #print("第%d步" % i)
    return run

#执行步进
if __name__ == '__main__':
    try:

        step = raw_input("走几步")
        step = int(step)

        #最大步长
        max_step = 4
        if step > max_step:
            print('bad step')
            sys.exit()

        #注册一个电平RISING事件 设置防抖时间
        GPIO.add_event_detect(uPin, GPIO.RISING, bouncetime=1000)

        #动作执行
        ret = walk(step, 'forward')  ##正向走对应步数
        time.sleep(1)
        walk(step, 'backward') ##反向走对应的步数
    except KeyboardInterrupt:
        pass

    GPIO.cleanup()
